/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef ERROR_HPP
#define ERROR_HPP

#include <DxcDataTypes.hpp>
#include <DxcDefs.hpp>

namespace Dxc
{
/**
 * @brief Error message.
 */
class DXCAPI_EXPORT ErrorData : public DxcData
{
public:
    /**
     * @brief Constructor.
     *
     * @param timestamp - message time.
     * @param error - string describing the error.
     */
    ErrorData(Timestamp timestamp, const std::string& error);

    /**
     * @brief Returns the error message string.
     */
    std::string getError() const;

    virtual std::ostream &put(std::ostream &) const;

    virtual ErrorData* clone() const;
private:
    ErrorData();

    std::string error_;
};
}

#endif
