/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <DataTypes/ProfilingData.hpp>

using namespace Dxc;
using namespace std;

ProfilingData::ProfilingData(Timestamp timestamp,
                             const unsigned long cpuTime,
                             const unsigned long peakMemory)
    : DxcData(timestamp)
{
    cpuTime_ = cpuTime;
    peakMemory_ = peakMemory;
}

ProfilingData::ProfilingData(const unsigned long cpuTime,
                             const unsigned long peakMemory)
    : DxcData()
{
    cpuTime_ = cpuTime;
    peakMemory_ = peakMemory;
}

ProfilingData* ProfilingData::clone() const
{
    return new ProfilingData(*this);
}

ostream &ProfilingData::put(ostream &out) const
{
    out << "profilingInfo @" << this->getTimeStamp();
    if (this->getSource() != "")
        out << " <" << this->getSource() << ">";
    out << " cpuTime = " << cpuTime_ << ", maxMem = " << peakMemory_ << ";" << endl;
    out.flush();
    return out;
}
