package org.dxc.evaluator.metrics;

import java.util.LinkedList;
import java.util.List;

public class Average implements DAMetricCalculator {

    private List<Double> points;
    private double score;
    private int minPoints = -1;

    public Average() {
        points = new LinkedList<Double>();
        score = Double.NaN;
        minPoints = -1;
    }

    public void addSMCalculator(ScenarioMetricCalculator smc) {
        Double d = smc.getScore();
        if (!d.isNaN())
            points.add(smc.getScore());
    }

    public void calculate() {
        double total = 0;
        for (Double d : points)
            total += d;

        if (points.size() != 0 && points.size() >= minPoints)
            this.score = total / points.size();
        else
            this.score = Double.NaN;
    }

    public double getScore() {
        if (points.size() != 0 && points.size() >= minPoints)
            return score;
        else
            return Double.NaN;
    }

    public void setMinDataPoints(int min) {
        minPoints = min;
    }

    public void print() {
        System.out.println("Average: " + this.getScore());
    }
}
