/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia
  
  The DXC Framework is free software: you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by the 
  Free Software Foundation, either version 3 of the License, or (at your 
  option) any later version. 

  This program is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
  details. 

  You should have received a copy of the GNU Lesser General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/> 
 */
package org.dxc.standaloneSDS;

import java.io.PrintStream;

import org.dxc.api.datatypes.DxcData;
import org.dxc.api.datatypes.ScenarioStatusData;
import org.dxc.api.DxcCallback;

public class WriteToFileCallback extends DxcCallback {
    private PrintStream out;

    public WriteToFileCallback(PrintStream out) {
        this.out = out;
    }

    public void processData(DxcData data) {
        if (data instanceof ScenarioStatusData) {
            if (((ScenarioStatusData) data).getStatus().equals(
                    ScenarioStatusData.DA_READY)) {
                synchronized (this) {
                    notifyAll();
                }
            }
        }
        if (out != null) {
            data.put(out);
            out.flush();
        }
    }
}