/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifdef _WIN32

#include <windows.h>
#include <iostream>
#include <DataTypes/DxcException.hpp>
#include <WinFileLister.hpp>

using namespace Dxc;
using namespace std;

vector<string> WinFileLister::getDirectories(string directory)
{
    WIN32_FIND_DATA ffd;
    HANDLE hFind;

    hFind = FindFirstFile((directory + "\\*").c_str(), &ffd);

    if (hFind == INVALID_HANDLE_VALUE)
        throw DxcException(string("unable to list directory: ") + directory);

    vector<string> ret;

    do
    {
        if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
            if (ffd.cFileName[0] != '.')
                ret.push_back(string(ffd.cFileName) + "\\");
    }
    while (FindNextFile(hFind, &ffd) != 0);

    FindClose(hFind);

    return ret;
}

vector<string> WinFileLister::getFiles(string directory)
{
    WIN32_FIND_DATA ffd;
    HANDLE hFind;

    hFind = FindFirstFile((directory + "\\*").c_str(), &ffd);

    if (hFind == INVALID_HANDLE_VALUE)
        throw DxcException(string("unable to list directory: ") + directory);

    vector<string> ret;

    do
    {
        if (!(ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
            ret.push_back(ffd.cFileName);
    }
    while (FindNextFile(hFind, &ffd) != 0);

    FindClose(hFind);

    return ret;
}

#endif
